/***************************************************************************

 ***************************************************************************/


#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#ifndef ASTAR_TEST
#define ASTAR_TEST
    
#include <iostream>
#include <cstdlib>
#include <vector>

#include "AStarUse.h"
#include "WaypointGridMapping.h"

#endif
    
using namespace std;

int main(int argc, char *argv[]) {
  int i;
  vector<ai_waypoint> vector_ai_waypoint;
  ai_waypoint startNode;
  startNode.id = 0;
  startNode.x_l = 0;
  startNode.y_l = 0;
  startNode.psi_l = 0;
  startNode.circle_of_acceptance = 10;
  
  ai_waypoint goalNode;
  goalNode.id = 2;
  goalNode.x_l = 4;
  goalNode.y_l = 4;
  goalNode.psi_l = 0;
  goalNode.circle_of_acceptance = 10;
  
  PrintWorldMap();
  InitMap(10, 15);
  PrintWorldMap();
  
  /**
   * Set weights in map
   */

  SetMapWeight(2,5,5);
  SetMapWeight(1,5,5);
  SetMapWeight(0,5,9);
  SetMapWeight(3,4,9);
  PrintWorldMap();
  
  ai_waypoint returnNode;
  vector_ai_waypoint = AStarUse(startNode, goalNode);
  int vectorSize = vector_ai_waypoint.size();
  for(i = 0; i < vectorSize; i++){
    returnNode = vector_ai_waypoint.at(i);
    cout << "returnNode.x_l = " << returnNode.x_l << " returnNode.y_l = " << returnNode.y_l << endl;
  }
  vector_ai_waypoint.clear();
  cout << "vectorSize = " << vector_ai_waypoint.size() << endl;

  return EXIT_SUCCESS;
}
