
#include <avr/io.h>
#include <avr/interrupt.h>

#include <util/delay.h>

#include "at90can128_driver.h"


int init_ext_interrupts(int int_nr){
	if(int_nr == 0){
		EICRA |= (1 << ISC01)|(1 << ISC00);
		DDRD &= ~(1 << INT0);
		PORTD |= (1 << PD0); // Enable intern pull-up
	}
	else if(int_nr == 1){
		EICRA |= (1 << ISC11)|(1 << ISC10);
		DDRD &= ~(1 << INT1);
		PORTD |= (1 << PD1); // Enable intern pull-up
	}
	else if(int_nr == 2){
		EICRA |= (1 << ISC21)|(1 << ISC20);
		DDRD &= ~(1 << INT2);
		PORTD |= (1 << PD2); // Enable intern pull-up
	}
	else if(int_nr == 3){
		EICRA |= (1 << ISC31)|(1 << ISC30);
		DDRD &= ~(1 << INT3);
		PORTD |= (1 << PD3); // Enable intern pull-up
	}
	else if(int_nr == 4){
		EICRB |= (1 << ISC41)|(1 << ISC40);
		DDRE &= ~(1 << INT4);
		PORTE |= (1 << PE4); // Enable intern pull-up
	}
	else if(int_nr == 5){
		EICRB |= (1 << ISC51)|(1 << ISC50);
		DDRE &= ~(1 << INT5);
		PORTE |= (1 << PE5); // Enable intern pull-up
	}
	else if(int_nr == 6){
		EICRB |= (1 << ISC61)|(1 << ISC60);
		DDRE &= ~(1 << INT6);
		PORTE |= (1 << PE6); // Enable intern pull-up
	}
	else if(int_nr == 7){
		EICRB |= (1 << ISC71)|(1 << ISC70);
		DDRE &= ~(1 << INT7);
		PORTE |= (1 << PE7); // Enable intern pull-up
	}
	
	EIMSK |= (1 << int_nr);
	
	return 0;
}

int disable_ext_interrupt(int int_nr){
	EIMSK &= ~(1 << int_nr);
	return 0;
}

ISR( SIG_INTERRUPT0 ) {
	// Send start message to robot
	int i;
	for(i = 0; i < 50; i++)
		_delay_ms(30);
	if((PIND & 0x01))
	send_can_start_message();

}

ISR( SIG_INTERRUPT1 ) {
	int i;
if(!(PIND & 0x01)){
	for(i = 0; i < 50; i++)
		_delay_ms(30);
	if((PIND & 0x02))
	send_can_reset_message();
}
}

ISR( SIG_INTERRUPT2 ) {
	int i;
if(!(PIND & 0x01)){
	for(i = 0; i < 50; i++)
		_delay_ms(30);	
	if((PIND & 0x04))
	send_can_team_color_red_message();
}

}
ISR( SIG_INTERRUPT3 ) {
		int i;
if(!(PIND & 0x01)){
	for(i = 0; i < 50; i++)
		_delay_ms(30);
	if((PIND & 0x08))
	send_can_team_color_blue_message();
}
}
ISR( SIG_INTERRUPT4 ) {
}
ISR( SIG_INTERRUPT5 ) {
}
ISR( SIG_INTERRUPT6 ) {
}
ISR( SIG_INTERRUPT7 ) {
}



