/*
** ** ** ** ** **  Begin header  ** ** ** ** ** ** **
**
** Project : Byggelab i faget TTK4155 Industrielle Datasystemers Konstruksjon 2005
** Filename : servo_pwm_driver.h
** Version : 1
** Date : 07.11.2005
**
** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** **
**
** Copyright (c) 2005, Kristian M. Knausgrd, Gunnar Kjemphol
** All rights reserved.
**
** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** **

VERSION LOG:
-----------
Version: 1
Date: 07.11.2005
Authors: Kristian M. Knausgrd, Gunnar Kjemphol
Coauthors: <none>
Description : Original version.
Target platform: ATMega128

FILE FUNCTIONALITY DESCRIPTION:
-----------
Servo driver for 1 standard PWM servo using timers on ATMega128.

** ** ** ** ** ** ** End header ** ** ** ** ** ** ** **
*/

// Ensure that PI constant is available without including math.h.
#ifndef PI
#define PI 3.1415927
#endif

/**
* Start timer in pwm mode, and set servo positioned at neutral position (0 degrees).
*/
void servo_init( void );

/**
* Set servo position in radians (-pi to pi).
*/
void servo_set_position_rad( double );

/**
* Set servo position in degrees (-90 to 90),
*/
void servo_set_position_deg( int );

/**
* Set the current servo position as servo center position
*/
void set_servo_center( void );
