/***************************************************************************

 ***************************************************************************/

#include "AStarUse.h"

int worldMap[WORLD_GRID_X * WORLD_GRID_Y];

vector<ai_waypoint> AStarUse(ai_waypoint& startNode, ai_waypoint& goalNode){
  vector<ai_waypoint> vector_ai_waypoint;
  ai_waypoint ai_waypoint_Node;
  ai_waypoint_Node.x_l = 0;
  ai_waypoint_Node.y_l = 0;
  
  cout << "startNode.x_l " << startNode.x_l << endl;
  cout << "startNode.y_l " << startNode.y_l << endl;
  cout << "goalNode.x_l " << goalNode.x_l << endl;
  cout << "goalNode.y_l " << goalNode.y_l << endl;
  
  cout << "Using A* " << endl;
//  PrintWorldMap();
//  InitMap(WORLD_GRID_X, WORLD_GRID_Y);
//  PrintWorldMap();



  MapSearchNode nodeStart;
  nodeStart.x = startNode.x_l;
  nodeStart.y = startNode.y_l;

  MapSearchNode nodeEnd;
  nodeEnd.x = goalNode.x_l;
  nodeEnd.y = goalNode.y_l;

  /**
   * Set start and goal states
   */
  AStarSearch<MapSearchNode> astarsearch;
  astarsearch.SetStartAndGoalStates( nodeStart, nodeEnd );

  unsigned int SearchState;
  unsigned int SearchSteps = 0;

  do
  {
    SearchState = astarsearch.SearchStep();

    SearchSteps++;

#if DEBUG_LISTS

    cout << "Steps:" << SearchSteps << "\n";

    int len = 0;

    cout << "Open:\n";
    MapSearchNode *p = astarsearch.GetOpenListStart();
    while( p ){
      len++;
#if !DEBUG_LIST_LENGTHS_ONLY
      ((MapSearchNode *)p)->PrintNodeInfo();
#endif
      p = astarsearch.GetOpenListNext();
    }

    cout << "Open list has " << len << " nodes\n";

    len = 0;

    cout << "Closed:\n";
    p = astarsearch.GetClosedListStart();
    while( p )
    {
      len++;
#if !DEBUG_LIST_LENGTHS_ONLY			
      p->PrintNodeInfo();
#endif			
      p = astarsearch.GetClosedListNext();
    }

    cout << "Closed list has " << len << " nodes\n";
#endif

  }while( SearchState == AStarSearch<MapSearchNode>::SEARCH_STATE_SEARCHING ); //do 


  if( SearchState == AStarSearch<MapSearchNode>::SEARCH_STATE_SUCCEEDED )
  {
    cout << "Search found goal state\n";

    MapSearchNode *node = astarsearch.GetSolutionStart();

#if DISPLAY_SOLUTION
    cout << "Displaying solution\n";
#endif
    int steps = 0;

    node->PrintNodeInfo();
    for( ;; )
    {
      node = astarsearch.GetSolutionNext();

      if( !node )
      {
	break;
      }

      node->PrintNodeInfo();
      ai_waypoint_Node = node->ReturnNodeInfo();
      cout << "ai_waypoint_Node.x_l " << ai_waypoint_Node.x_l << endl;
      cout << "ai_waypoint_Node.y_l " << ai_waypoint_Node.y_l << endl;
      
      vector_ai_waypoint.push_back(ai_waypoint_Node);
      steps ++;

    };

    cout << "Solution steps " << steps << endl;

  /**
     * Once you're done with the solution you can free the nodes up
   */
    astarsearch.FreeSolutionNodes();

  }
  else if( SearchState == AStarSearch<MapSearchNode>::SEARCH_STATE_FAILED ){
    cout << "Search terminated. Did not find goal state\n";
  }
  /**
   * Display the number of loops the search went through
   */
  cout << "SearchSteps : " << SearchSteps << "\n";


  astarsearch.EnsureMemoryFreed();
  
  return vector_ai_waypoint;
}

int InitMap ( int size_x, int size_y ){
  int i;
  for(i = 0; i < (size_x * size_y); i++){
    worldMap[i] = 1; 
  }

  return 0;
}

int SetMapWeight( int x, int y, int weight ){
  if(weight < 1)
    weight = 1;
  else if(weight > 9)
    weight = 9;
  if( x < 0 ||
      x >= WORLD_GRID_X ||
      y < 0 ||
      y >= WORLD_GRID_Y){
        return -1;
  }
  else {
    worldMap[(y*WORLD_GRID_X) + x ] = weight;
  }

  return 0;
}
/*
    int PrintWorldMap(){
    int x,y;
    cout << "worldMap " << endl;
    for(y = 0; y < WORLD_GRID_Y; y++) {
    for(x = 0; x < WORLD_GRID_X; x++){
    cout << worldMap[(y*WORLD_GRID_X) + x ];
}
    cout << endl;
}
    cout << endl;

}
*/
int PrintWorldMap(){
  int x,y;
  cout << "worldMap " << endl;
  for(y = WORLD_GRID_Y-1; y >= 0; y--) {
    for(x = WORLD_GRID_X-1; x >= 0; x--){
      cout << worldMap[(y*WORLD_GRID_X) + x ];
    }
    cout << endl;
  }
  cout << endl;
}


int GetMap( int x, int y ){
  if( x < 0 ||
      x >= WORLD_GRID_X ||
      y < 0 ||
      y >= WORLD_GRID_Y){
        return 9;	 
  }

  return worldMap[(y*WORLD_GRID_X)+x];
}

