#ifndef BATTERY_SORT_H
#define BATTERY_SORT_H

/**
 *  Eurobot 2007
 *  PlansysObservation.h
 *  Gunnar Kjemphol <gunnar@kjemphol.no>
 * 
 * 
 *  This is a child class of Observer class
 * 
 *  The PlansysObservation objects can call Battery memberfunction 
 *  Update() when a new observation is recieved. 
 * 
 * 
 */

#include <math.h>

#include "Observer.h"
#include "PlansysObservation.h"
#include "mainplansys.h"
#include "waypoint.h"
#include "posix_message_config.h"
#include "observations.h"
#include "init.h"


class BatterySort: public Observer {
  public:
    BatterySort( PlansysObservation * , int theTeamColor );
    ~BatterySort();
    void Update( Subject *, int typeOfObservation);
    int GetPriority();
    int AgentGlobalPriority();
    int GetAction( controll_struct *ai_controll_struct );
    int SetAgentActive( int active );
    int StrategyInterrupted();
    int GetInterruptAction(interrupt_controll_struct *interrupt_controll);
  private:
  /**
   * Give the Agent a priority in the constructor [0-9]
   * if the agentPriority is -1 the agent is inactive in priority
   */
    int agentPriority;
    int inAction;
    int activeStrategy;
    int batteryRelease;
    int batteryReleased;
    int waitForBatteryReleased;
    int lastWaypointReached;
    PlansysObservation *_subject; // referece to subject
    ai_waypoint ai_waypoint_3d;
    ai_waypoint battery_bin_ai_waypoint;
    proxy_message my_proxy_message;
    cv_observation my_cv_observation;
    controll_struct local_controll_struct;
};

#endif
