#ifndef BOTTLE_BOX_SORT_H
#define BOTTLE_BOX_SORT_H

/**
 *  Eurobot 2007
 *  PlansysObservation.h
 *  Gunnar Kjemphol <gunnar@kjemphol.no>
 * 
 * 
 *  This is a child class of Observer class
 * 
 *  The PlansysObservation objects can call BottleBoxSort memberfunction 
 *  Update() when a new observation is recieved. 
 * 
 * 
 */

#include <math.h>

#include "Observer.h"
#include "PlansysObservation.h"
#include "mainplansys.h"
#include "waypoint.h"
#include "posix_message_config.h"
#include "observations.h"
#include "init.h"


class BottleBoxSort: public Observer {
  public:
    BottleBoxSort( PlansysObservation * , int theTeamColor );
    ~BottleBoxSort();
    void Update( Subject *, int typeOfObservation);
    int GetPriority();
    int AgentGlobalPriority();
    int GetAction( controll_struct *ai_controll_struct );
    int SetAgentActive( int active );
    int StrategyInterrupted();
    int GetInterruptAction(interrupt_controll_struct *interrupt_controll);
  
  private:
  /**
   * Give the Agent a priority in the constructor [0-9]
   * if the agentPriority is -1 the agent is inactive in priority
   */
    int agentPriority;
    int inAction;
    int activeStrategy;
    int bottleBoxRelease;
    int bottleBoxReleased;
    int waitForBottleBoxReleased;
    int lastWaypointReached;
    bool changeTheObservationType;
    bool lastWaypointSendt;
    bool turnAgainstBottlesAndBoxes;
    short lastWaypointId;
    bool pickUpWaypointReached;
    short pickUpWaypointId;
    bool pickUpMessageSendt;
    int typeOfPickUp;
    bool pickUpMessageRecieved;
    
    PlansysObservation *_subject; // referece to subject
//    robot_state_3dof_posix robot_state_3d;
    ai_waypoint ai_waypoint_3d;
    ai_waypoint red_bottle_bin_ai_waypoint;
    ai_waypoint red_box_bin_ai_waypoint;
    ai_waypoint blue_bottle_bin_ai_waypoint;
    ai_waypoint blue_box_bin_ai_waypoint;
    ai_waypoint current_bin_ai_waypoint;
    ai_waypoint pick_up_waypoint;
    ai_waypoint local_ai_waypoint;
    proxy_message my_proxy_message;
    cv_observation my_cv_observation;
    cv_observation color_cv_observation;
    controll_struct local_controll_struct;


};

#endif
