/**
 *  Eurobot 2007
 *  EmptyStrategy.cpp
 *  Gunnar Kjemphol <gunnar@kjemphol.no>
 */

#include "EmptyStrategy.h"


EmptyStrategy::EmptyStrategy ( PlansysObservation *s , int theTeamColor ){
  teamColor = theTeamColor;
  /**
   * Give the Agent a priority in the constructor [0-9]
   * if the agentPriority is -1 the agent is inactive
   */
  agentPriority = -1;
  inAction = INACTIVE;
  activeStrategy = INACTIVE;

  _subject = s;
  _subject->Attach(this);

  clear_controll_struct(&local_controll_struct);

  clear_robot_state_3d(&ai_waypoint_3d);
  clear_robot_state_3d(&ai_waypoint_reached);

  clear_cv_observation(&color_cv_observation);
  clear_cv_observation(&my_cv_observation);

}



EmptyStrategy::~EmptyStrategy (){
  _subject->Detach(this);
}

int EmptyStrategy::AgentGlobalPriority(){
      return agentPriority; 
}

int EmptyStrategy::SetAgentActive( int active_r ){
  inAction = active_r;
  activeStrategy = ACTIVE;
  if( active_r == INACTIVE) {
    agentPriority = 5;
    inAction = INACTIVE;
    activeStrategy = INACTIVE;
    clear_controll_struct(&local_controll_struct);
    
    clear_robot_state_3d(&ai_waypoint_3d);
    clear_robot_state_3d(&ai_waypoint_reached);

    clear_cv_observation(&color_cv_observation);
    clear_cv_observation(&my_cv_observation);
  }
}


int EmptyStrategy::GetPriority(){
  int priority = -1;

  return priority;
}


int EmptyStrategy::GetAction( controll_struct *ai_controll_struct ){

  return 0;
}

void EmptyStrategy::Update( Subject *theChangedSubject, int typeOfObservation){
  if( theChangedSubject == _subject ){
    if( typeOfObservation == MINOR_CV_OBSERVATION ){
      my_cv_observation = _subject->GetCvObservation();

    }
    else if( typeOfObservation == MINOR_CV_COLOR_OBSERVATION ){
      color_cv_observation = _subject->GetCvColorObservation();
    }
    else if( typeOfObservation == MINOR_NAVSYS_POSITION ){
      ai_waypoint_3d = _subject->GetPosObservation();
    }
    else if ( typeOfObservation == MINOR_NAVSYS_REACHED_WAYPOINT ) {
      ai_waypoint_reached = _subject->GetWaypointReachedObservation();
    }
    else if( typeOfObservation == MINOR_PROXY_MESSAGE ){
      my_proxy_message = _subject->GetProxyMessage();
      if( my_proxy_message.teamColor > 0 )
	teamColor = my_proxy_message.teamColor;
    }
  }
}

/**
 * The strategy is interrupted by anoter strategy
 * keep existing settings
 */
int EmptyStrategy::StrategyInterrupted() {

  return 0;
}

int EmptyStrategy::GetInterruptAction(interrupt_controll_struct *interrupt_controll) {

  return 0; 
}


