/**
 *  Eurobot 2007
 *  FirstStrategy.cpp
 *  Gunnar Kjemphol <gunnar@kjemphol.no>
 */

#include "FirstStrategy.h"


FirstStrategy::FirstStrategy ( PlansysObservation *s , int theTeamColor ){
  teamColor = theTeamColor;
  /**
   * Give the Agent a priority in the constructor [0-9]
   * if the agentPriority is -1 the agent is inactive in priority
   */
  agentPriority = 9;
  inAction = INACTIVE;
  activeStrategy = INACTIVE;
  lastWaypointReached = FALSE;
  batteryBinMessageRecieved = FALSE;
  _subject = s;
  _subject->Attach(this);

}

FirstStrategy::~FirstStrategy (){
  _subject->Detach(this);

}

int FirstStrategy::AgentGlobalPriority(){
  return agentPriority; 
}

int FirstStrategy::SetAgentActive( int active ){

  activeStrategy = active;
}


int FirstStrategy::GetPriority(){

  /**
   * This will be active in 10 sec
   */
  if( inAction == ACTIVE ) {
    cout << "First strategy FirstStrategy inAction == ACTIVE " << endl;
   return 600; 
    
  }
  if( local_time_message.timeLeft > (GAME_TIME - 10) ){
#ifdef DEBUG_TIME
    cout << " " << endl;
    cout << "local_time_message.timeLeft" << local_time_message.timeLeft << endl;
    cout << "(GAME_TIME - 10) " << (GAME_TIME - 10) << endl;
    cout << " " << endl;
#endif
    return 1600;
  }
  else {
    cout << "First strategy FirstStrategy return -10000 " << endl;
    agentPriority = -1;
    return -10000;
  }

}
/*
typedef struct ai_waypoint {
  short x_l;
  short y_l;
  float psi_l;
  short circle_of_acceptance;
};
typedef struct controll_struct {
  bool clearWaypoints;
  int commands[NUMBER_OF_COMMANDS];
  std::vector<ai_waypoint> _ai_waypoint;
*/
int FirstStrategy::GetAction( controll_struct *ai_controll_struct ){
  
  cout << " ACTIVE STRATEGY FIRSTSTRATEGY " << endl;
  if(inAction == INACTIVE){
//    cout << " ACTIVE STRATEGY FIRSTSTRATEGY INACTIVE set ACTIVE" << endl;
    inAction = ACTIVE;
    
    /**
     * Set hte path from the position of the battery bin, and the team color.
     */
   // if(battery_bin_cv_observation.y == 1500){
    if(teamColor == TEAM_COLOR_BLUE){
   //     (ai_controll_struct)->clearWaypoints = 0;
      cout << "firstRun: TEAM_COLOR_BLUE " << endl;
      ai_waypoint new_ai_waypoint;

      new_ai_waypoint.x_l = 600;
      new_ai_waypoint.y_l = 600;
      new_ai_waypoint.psi_l = (M_PI/8);
      new_ai_waypoint.circle_of_acceptance = 100;
      (ai_controll_struct)->_ai_waypoint.push_back(new_ai_waypoint);
      memcpy ((void *)(&last_ai_waypoint), (void *)(&new_ai_waypoint), sizeof(ai_waypoint) );

      new_ai_waypoint.x_l = 1200;
      new_ai_waypoint.y_l = 480;
      new_ai_waypoint.psi_l = 0;
      new_ai_waypoint.circle_of_acceptance = 100;
      (ai_controll_struct)->_ai_waypoint.push_back(new_ai_waypoint);
      memcpy ((void *)(&last_ai_waypoint), (void *)(&new_ai_waypoint), sizeof(ai_waypoint) );

      new_ai_waypoint.x_l = 2000;
      new_ai_waypoint.y_l = 500;
      new_ai_waypoint.psi_l = (3*M_PI/8);
      new_ai_waypoint.circle_of_acceptance = 100;
      new_ai_waypoint.id = 1975;
      (ai_controll_struct)->_ai_waypoint.push_back(new_ai_waypoint);
      memcpy ((void *)(&last_ai_waypoint), (void *)(&new_ai_waypoint), sizeof(ai_waypoint) );

 
    }
    else if(teamColor == TEAM_COLOR_RED){
      cout << "firstRun: TEAM_COLOR_RED " << endl;
      ai_waypoint new_ai_waypoint;

      new_ai_waypoint.x_l = 2400;
      new_ai_waypoint.y_l = 600;
      new_ai_waypoint.psi_l = (M_PI);
      new_ai_waypoint.circle_of_acceptance = 100;
      (ai_controll_struct)->_ai_waypoint.push_back(new_ai_waypoint);
      memcpy ((void *)(&last_ai_waypoint), (void *)(&new_ai_waypoint), sizeof(ai_waypoint) );

      new_ai_waypoint.x_l = 1800;
      new_ai_waypoint.y_l = 480;
      new_ai_waypoint.psi_l = (M_PI);
      new_ai_waypoint.circle_of_acceptance = 100;
      (ai_controll_struct)->_ai_waypoint.push_back(new_ai_waypoint);
      memcpy ((void *)(&last_ai_waypoint), (void *)(&new_ai_waypoint), sizeof(ai_waypoint) );

      new_ai_waypoint.x_l = 1000;
      new_ai_waypoint.y_l = 500;
      new_ai_waypoint.psi_l = (5.0 * M_PI/8.0);
      new_ai_waypoint.circle_of_acceptance = 100;
      new_ai_waypoint.id = 1975;
	(ai_controll_struct)->_ai_waypoint.push_back(new_ai_waypoint);
	memcpy ((void *)(&last_ai_waypoint), (void *)(&new_ai_waypoint), sizeof(ai_waypoint) );
      }
      else
	return -1000;

    return 600;
  }
  else {
    if(activeStrategy == ACTIVE){
      cout << "FirstStrategy: activeStrategy == ACTIVE " << endl;
      cout << "FirstStrategy: TEAM_COLOR_ " << teamColor << endl;
      if(lastWaypointReached == TRUE) {
	cout << "FirstStrategy: lastWaypointReached == TRUE " << endl;
        (ai_controll_struct)->clearTheActiveStrategy = true;
	activeStrategy = INACTIVE;
	agentPriority = -100;
        return 1000;
      }
    }
    else
      return -1000;
    
  }
}

void FirstStrategy::Update( Subject *theChangedSubject, int typeOfObservation){
  int i;
  if( theChangedSubject == _subject ){
    if( typeOfObservation == MINOR_PROXY_MESSAGE ){
      my_proxy_message = _subject->GetProxyMessage();
      if( my_proxy_message.teamColor > 0 )
	teamColor = my_proxy_message.teamColor;

    }
    else if ( typeOfObservation == MINOR_NAVSYS_REACHED_WAYPOINT ) {
      ai_waypoint last_ai_waypoint_reached;
      last_ai_waypoint_reached = _subject->GetWaypointReachedObservation();
      for(i = 0; i < 5; i++){
	sleep(1);
      cout << "last_ai_waypoint_reached.x_l" << last_ai_waypoint_reached.x_l << endl;
      cout << "last_ai_waypoint_reached.y_l" << last_ai_waypoint_reached.y_l << endl;
      }
      
      
      if( (last_ai_waypoint.x_l >= last_ai_waypoint_reached.x_l - 10) && (last_ai_waypoint.x_l <= last_ai_waypoint_reached.x_l + 10) &&
	   (last_ai_waypoint.y_l >= last_ai_waypoint_reached.y_l - 10) &&
	   (last_ai_waypoint.y_l <= last_ai_waypoint_reached.y_l + 10) ){
      
      /*
      if( (last_ai_waypoint_reached.x_l == last_ai_waypoint.x_l) && (last_ai_waypoint_reached.y_l == last_ai_waypoint.y_l) ){
	*/
	lastWaypointReached = TRUE;
	for(i = 0; i < 45; i++){
	 sleep(1);
	 cout << "Last waypoint reached" << endl;
	 cout << "last_ai_waypoint_reached.x_l" << last_ai_waypoint_reached.x_l << endl;
	 cout << "last_ai_waypoint_reached.y_l" << last_ai_waypoint_reached.y_l << endl;
	}
      }
    }
    else if( typeOfObservation == MINOR_NAVSYS_POSITION ){
//      robot_state_3d = _subject->GetPosObservation();
      ai_waypoint_3d = _subject->GetPosObservation();
#ifdef DEBUG_OBS_PRINT
cout << "Type of observation POSITION FirstStrategy" << endl;
#endif
    }
    else if( typeOfObservation == MINOR_CV_OBSERVATION ){
      my_cv_observation = _subject->GetCvObservation();
      if( my_cv_observation.type == BATTERY_BIN ) {
	/**
	 * Set the position of the battery bin
	 */
	memcpy((void *)&battery_bin_cv_observation, (void *)&my_cv_observation, sizeof(cv_observation));
	batteryBinMessageRecieved = TRUE;
	
      }
#ifdef DEBUG_OBS_PRINT
      cout << "Type of observation CV FirstStrategy" << endl;
#endif
    }
    else if( typeOfObservation == GAME_TIME_MESSAGE ){
#ifdef DEBUG_OBS_PRINT
      cout << "Type of observation TIME FirstStrategy" << endl;
#endif
      local_time_message = _subject->GetTimeObservation();
#ifdef DEBUG_OBS_PRINT      
      cout << "local_time_message.timeLeft " << local_time_message.timeLeft << endl;
      cout << endl;
      cout << endl;
      cout << endl;
      
#endif
    }
#ifdef DEBUG_OBS_PRINT
    cout << "Update FirstStrategy" << endl;
    cout << " " << endl;
#endif
  }

}

/**
 * The strategy is interrupted by anoter strategy
 * keep existing settings
 */
int FirstStrategy::StrategyInterrupted() {

  
  return 0;
}

int FirstStrategy::GetInterruptAction(interrupt_controll_struct *interrupt_controll) {
  
  return 0; 
}


