#ifndef FIRST_STRATEGY_H
#define FIRST_STRATEGY_H

/**
 *  Eurobot 2007
 *  FirstStrategy.h
 *  Gunnar Kjemphol <gunnar@kjemphol.no>
 * 
 * 
 *  This is a child class of Observer class
 * 
 *  This Agent is suposed to have a high priority when the game starts,
 *  it will do some preprogramed actions
 * 
 * 
 */

#include <math.h>

#include "Observer.h"
#include "PlansysObservation.h"
#include "mainplansys.h"
#include "waypoint.h"
#include "posix_message_config.h"
#include "init.h"

class FirstStrategy: public Observer {
  public:
  /**
   * Give the Agent a priority in the constructor [0-9]
   * if the agentPriority is -1 the agent is inactive in priority
   */
    FirstStrategy( PlansysObservation * , int theTeamColor );
    ~FirstStrategy();
    void Update( Subject *, int typeOfObservation);
    int GetPriority();
    int AgentGlobalPriority();
    int GetAction( controll_struct *ai_controll_struct );
    int SetAgentActive( int active );
    int StrategyInterrupted();
    int GetInterruptAction(interrupt_controll_struct *interrupt_controll);
  
  private:
    int agentPriority;
    int inAction;
    int activeStrategy;
    
    int lastWaypointReached;
    int batteryBinMessageRecieved;

    PlansysObservation *_subject; // referece to subject
//    robot_state_3dof_posix robot_state_3d;
    ai_waypoint ai_waypoint_3d;
    ai_waypoint last_ai_waypoint;
    cv_observation my_cv_observation;
    cv_observation battery_bin_cv_observation;
    proxy_message my_proxy_message;
    time_message local_time_message;
    controll_struct local_controll_struct;
};

#endif

