#ifndef OBSERVER_H
#define OBSERVER_H

/**
 * Eurobot 2007
 * Observer.h
 * Gunnar Kjemphol <gunnar@kjemphol.no>
 */

#include <list>
#include <iostream>
#include <vector>

#include "mainplansys.h"



using namespace std;

class Subject;

class Observer {

  public:
    Observer( );
    ~Observer();
    virtual void Update(Subject* theChangeSubject, int typeOfObservation) = 0;
    virtual int GetPriority() = 0;
    virtual int AgentGlobalPriority() = 0;
    virtual int GetAction( controll_struct *ai_controll_struct ) = 0;
    virtual int SetAgentActive( int active ) = 0;
    virtual int StrategyInterrupted() = 0;
    virtual int GetInterruptAction(interrupt_controll_struct *interrupt_controll) = 0;
    int teamColor;

  private:


};

class Subject {
  public:
    Subject() {};
    ~Subject() {};
    void Attach( Observer* );
    void Detach( Observer* );
    void Notify(int typeOfObservation);
    vector<Observer *> _observers;
  private:

  protected:
    

};


#endif
