/**
 *  Eurobot 2007
 *  PlansysObservation.h
 *  Gunnar Kjemphol <gunnar@kjemphol.no>
 * 
 * 
 *  This is a child class of Subject class
 * 
 *  This class recieves observations from CV, Navsys, and other related 
 *  observations
 * 
 */
#ifndef PLANSYS_OBSERVATION_H
#define PLANSYS_OBSERVATION_H

#include "Observer.h"
//#include "mainplansys.h"
#include "observations.h"
#include "waypoint.h"
#include "MessageHandler.h"
#include "posix_message_queue.h"
#include "posix_message_config.h"

class PlansysObservation : public Subject {
  public:
    PlansysObservation();
    ai_waypoint GetPosObservation();
    ai_waypoint GetWaypointReachedObservation();
    cv_observation GetCvObservation();
    cv_observation GetCvColorObservation();
    time_message GetTimeObservation();
    proxy_message GetProxyMessage();
    collision_detection_message GetCollisionMessage();
    int NewObservation(pmq_message pm, int typeOfObservation);
    void GetAgentPriority( void );
    int PerformInterruptStrategy( interrupt_controll_struct *ai_interrupt_controll_struct );
    int PerformStrategy( controll_struct *ai_controll_struct );
    int ClearTheActiveStrategy();
    int GetAvtiveStrategy();

    vector<int> interruptedStrategyes;

  private:
    int activeStrategy;
    int activeStrategyValue;
    int strategyCandidate;
    int ChoseStrategy();
    int bottleBoxTypeOfPickUp;
    ai_waypoint ai_waypoint_3d, *ai_waypoint_3d_ptr;
    ai_waypoint last_ai_waypoint_3d_reached;
    cv_observation my_cv_observation;
    cv_observation color_cv_observation;
    proxy_message my_proxy_message;
    collision_detection_message collision_message;
    time_message main_time;

};

#endif
