#include "init.h"

extern int teamColor;


extern "C" int clear_interrupt_controll_struct( interrupt_controll_struct *ai_interrupt_controll_struct ) {
  ai_interrupt_controll_struct->stopRobot = 0;
  ai_interrupt_controll_struct->clearActiveStrategy = 0;
  ai_interrupt_controll_struct->_interrupt_ai_waypoint.clear();
  
  
  return 0;
}

extern "C" int clear_controll_struct( controll_struct *ai_controll_struct ){
  int i;
  ai_controll_struct->clearWaypoints = false;
  ai_controll_struct->clearTheActiveStrategy = false;
  ai_controll_struct->setMaxSpeed = false;
  ai_controll_struct->interrupt = false;
  ai_controll_struct->activeStrategyInterrupted = INACTIVE;
  ai_controll_struct->maxSpeed_mps = 10.0;
  ai_controll_struct->command.clear();
  ai_controll_struct->_ai_waypoint.clear();
  ai_controll_struct->_ai_waypoint_rel_robot.clear();
  
  return 0;
}

/**
 * Clear the robot state vector
 */

extern "C" void clear_robot_state_3d(ai_waypoint *ai_waypoint_3d) {
  ai_waypoint_3d->x_l = 0;
  ai_waypoint_3d->y_l = 0;
  ai_waypoint_3d->psi_l = 0.0;
  ai_waypoint_3d->circle_of_acceptance = 50;

}

extern "C" void clear_cv_observation(cv_observation *my_cv_observaiton){
  my_cv_observaiton->type = NOTHING;
  my_cv_observaiton->x = 0;
  my_cv_observaiton->y = 0;
  my_cv_observaiton->ret = 0;
  my_cv_observaiton->teamColor = 0;
  
  
}

int firstRun(MessageHandler *navsysMessageHandler){
  int i;
  ai_waypoint interrupt_ai_waypoint;
  if(teamColor == TEAM_COLOR_BLUE){
   //     (ai_controll_struct)->clearWaypoints = 0;
    cout << "firstRun: TEAM_COLOR_BLUE " << endl;
    ai_waypoint new_ai_waypoint;

    new_ai_waypoint.x_l = 600;
    new_ai_waypoint.y_l = 600;
    new_ai_waypoint.psi_l = (M_PI/8);
    new_ai_waypoint.circle_of_acceptance = 100;
    navsysMessageHandler->sendMessage( (char *)&new_ai_waypoint, (int)sizeof(ai_waypoint), MINOR_NAVSYS_SET_WAYPOINT, PRIORITY_HIGH );

    new_ai_waypoint.x_l = 1200;
    new_ai_waypoint.y_l = 480;
    new_ai_waypoint.psi_l = 0;
    new_ai_waypoint.circle_of_acceptance = 100;
    navsysMessageHandler->sendMessage( (char *)&new_ai_waypoint, (int)sizeof(ai_waypoint), MINOR_NAVSYS_SET_WAYPOINT, PRIORITY_HIGH);

    new_ai_waypoint.x_l = 2000;
    new_ai_waypoint.y_l = 500;
    new_ai_waypoint.psi_l = (3*M_PI/8);
    new_ai_waypoint.circle_of_acceptance = 100;
    new_ai_waypoint.id = 1975;
    navsysMessageHandler->sendMessage( (char *)&new_ai_waypoint, (int)sizeof(ai_waypoint), MINOR_NAVSYS_SET_WAYPOINT, PRIORITY_HIGH );

 
  }
  else if(teamColor == TEAM_COLOR_RED){
    cout << "firstRun: TEAM_COLOR_RED " << endl;
   //     (ai_controll_struct)->clearWaypoints = 0;
    ai_waypoint new_ai_waypoint;
    ai_waypoint pick_up_waypoint;

    new_ai_waypoint.x_l = 2400;
    new_ai_waypoint.y_l = 600;
    new_ai_waypoint.psi_l = (M_PI);
    new_ai_waypoint.circle_of_acceptance = 100;
    navsysMessageHandler->sendMessage( (char *)&new_ai_waypoint, (int)sizeof(ai_waypoint), MINOR_NAVSYS_SET_WAYPOINT, PRIORITY_HIGH );

    new_ai_waypoint.x_l = 1800;
    new_ai_waypoint.y_l = 480;
    new_ai_waypoint.psi_l = (M_PI);
    new_ai_waypoint.circle_of_acceptance = 100;
    navsysMessageHandler->sendMessage( (char *)&new_ai_waypoint, (int)sizeof(ai_waypoint), MINOR_NAVSYS_SET_WAYPOINT, PRIORITY_HIGH );

    new_ai_waypoint.x_l = 1000;
    new_ai_waypoint.y_l = 500;
    new_ai_waypoint.psi_l = (5.0 * M_PI/8.0);
    new_ai_waypoint.circle_of_acceptance = 100;
    new_ai_waypoint.id = 1975;
    navsysMessageHandler->sendMessage( (char *)&new_ai_waypoint, (int)sizeof(ai_waypoint), MINOR_NAVSYS_SET_WAYPOINT, PRIORITY_HIGH );

  }
}


