#ifndef MAIN_PLANSYS_H
#define MAIN_PLANSYS_H

#include "debug.h"
#include "observation_structs.h"
#include <vector>
#include <signal.h>

void catch_sighup(int sig_num);

const int GAME_TIME = 88;
const int GAME_TIME_MESSAGE = 200;



const int TABLE_SIZE_X = 3000;
const int TABLE_SIZE_Y = 2100;

const int ACTIVE = 1;
const int INACTIVE = -1;
const int INTERRUPTED = -2;

const int FALSE = 0;
const int TRUE = 1;

const double MAX_SPEED_MPS = 10.0;


typedef struct time_message {
  int gameTime;
  int timeLeft;
  
};

/**
 * Command struct, this struct is the controll struct for 
 * communication between the AI system and the robot
 */


typedef struct controll_struct {
  bool setMaxSpeed;
  double maxSpeed_mps; 
  bool clearWaypoints;
  bool clearTheActiveStrategy;
  bool interrupt;
  int activeStrategyInterrupted;

  std::vector<int> command;
  /**
   * Pointer to waypoint struct
   */
  std::vector<ai_waypoint> _ai_waypoint;
  /**
   * Pointer to waypoint struct relative robot
   */
  std::vector<ai_waypoint> _ai_waypoint_rel_robot;
};

typedef struct interrupt_controll_struct {
  bool stopRobot;
  bool clearActiveStrategy;
  std::vector<ai_waypoint> _interrupt_ai_waypoint;
  
};



#endif
